//+------------------------------------------------------------------+
//|                                                   GG-RSI-CCI.mq4 |
//|                                         Copyright  2009, GGekko |
//|                                         http://www.fx-ggekko.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, GGekko"
#property link      "http://www.fx-ggekko.com"

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  YellowGreen
#property  indicator_color2  Gold
#property  indicator_color3  OrangeRed
#property  indicator_width1  2
#property  indicator_width2  2
#property  indicator_width3  2
#property indicator_minimum  0
#property indicator_maximum  1.5 

//---- indicator parameters
extern string   __Copyright__          = "www.fx-ggekko.com";
extern int      Avg_Period1            = 8;
extern int      Avg_Period2            = 14;
extern int      Ind_Period             = 20;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsPushNotif    = false;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;

//---- indicator buffers
double     BufferUp[];
double     BufferFlat[];
double     BufferDown[];

double     ind1[];
double     ind2[];

double     ind3[];
double     ind4[];
double     ind5[];
double     ind6[];
double     trend[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexStyle(2,DRAW_HISTOGRAM);
   
   
//---- indicator buffers mapping
   SetIndexBuffer(0,BufferUp);
   SetIndexBuffer(1,BufferFlat);
   SetIndexBuffer(2,BufferDown);
   SetIndexBuffer(3,ind1);
   SetIndexBuffer(4,ind2);
   SetIndexBuffer(5,trend);
   
   
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("GG-RSI-CCI ("+Avg_Period1+","+Avg_Period2+","+Ind_Period+") * www.fx-ggekko.com * ");
   
   
//---- initialization done
   return(0);
  }

int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- 

   ArrayResize(ind3,limit);
   ArrayResize(ind4,limit);
   ArrayResize(ind5,limit);
   ArrayResize(ind6,limit);


   for(int i=0; i<limit; i++)
      ind1[i]=iRSI(NULL,0,Ind_Period,PRICE_CLOSE,i);
      
   for(i=0; i<limit; i++)
      ind2[i]=iCCI(NULL,0,Ind_Period,PRICE_CLOSE,i);

      
   for(i=0; i<limit; i++)
      ind3[i]=iMAOnArray(ind1,0,Avg_Period1,0,MODE_SMMA,i);

   for(i=0; i<limit; i++)
      ind4[i]=iMAOnArray(ind1,0,Avg_Period2,0,MODE_SMMA,i);
      
   for(i=0; i<limit; i++)
      ind5[i]=iMAOnArray(ind2,0,Avg_Period1,0,MODE_SMMA,i);

   for(i=0; i<limit; i++)
      ind6[i]=iMAOnArray(ind2,0,Avg_Period2,0,MODE_SMMA,i);
      
   
   for(i=0; i<limit; i++)
   {   
   trend[i] = trend[i+1];
   if(ind3[i]>ind4[i] && ind5[i]>ind6[i])
      {
      BufferUp[i]=1;
      BufferFlat[i]=EMPTY_VALUE;
      BufferDown[i]=EMPTY_VALUE;
      trend[i] = 1;
      } 
   else if(ind3[i]<ind4[i] && ind5[i]<ind6[i])
      {
      BufferUp[i]=EMPTY_VALUE;
      BufferFlat[i]=EMPTY_VALUE;
      BufferDown[i]=1;
      trend[i] = -1;
      }
   else
      {
      BufferUp[i]=EMPTY_VALUE;
      BufferFlat[i]=1;
      BufferDown[i]=EMPTY_VALUE;
      trend[i] = 0;
      }
   }
   manageAlerts();      
   
//---- done
   return(0);
  }
//+------------------------------------------------------------------+

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static string   alertType1 = "";
      static datetime alertTime1 = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1)  doAlert(alertType1,alertTime1,"trend changed to up");
         if (trend[whichBar] == -1)  doAlert(alertType1,alertTime1,"trend changed to down");
         if (trend[whichBar] ==  0)  doAlert(alertType1,alertTime1,"trend changed to neutral");
      }
   }
}

//
//
//
//
//

void doAlert(string& previousAlert, datetime& previousTime, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," gg rsi cci ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol(),"gg rsi cci "),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol(),"gg rsi cci "+" "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}
  